%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Definitions of builtins of module IOExts:
%

:- use_module('../prologbasics').
:- use_module('../basics').


% create a new INET socket:
?- block socketINET(?,?,-,?).
socketINET(_,'$io'(Socket),E0,E) :-
        newSocket(Socket),
        E0=E.


% bind an INET socket to a port:
?- block prim_socketBind(?,?,?,?,-,?).
prim_socketBind(RSocket,RPort,_,'$io'('()'),E0,E) :-
	deref(RSocket,Socket),
	deref(RPort,Port),
        socketBind(Socket,_Host,Port),
        E0=E.


% set backlog queue of a socket:
?- block prim_socketListen(?,?,?,?,-,?).
prim_socketListen(RSocket,RLength,_,'$io'('()'),E0,E) :-
	deref(RSocket,Socket),
	deref(RLength,Length),
        socketListen(Socket,Length), !,
        E0=E.


% return the first connection to a socket as a reed/write stream:
?- block prim_socketAccept(?,?,?,-,?).
prim_socketAccept(RSocket,_,
		  '$io'('(,)'(ClientS,
			      '$stream'('$inoutstream'(InStream,OutStream)))),
		  E0,E) :-
	deref(RSocket,Socket),
        socketAccept(Socket,Client,InStream,OutStream),
	atom2String(Client,ClientS), !,
        E0=E.



% open a connection to a Unix socket:
?- block prim_connectToSocket(?,?,?,?,-,?).
prim_connectToSocket(RSHst,RSNr,_,
		     '$io'('$stream'('$inoutstream'(InStream,OutStream))),
		     E0,E) :-
	derefAll(RSHst,SHst), deref(RSNr,SNr),
        string2Atom(SHst,Host), !,
        newSocket(Socket),
        socketConnect(Socket,Host,SNr,InStream,OutStream), E0=E.


